
apiVersion: apps/v1
kind: Deployment
metadata:
  name: practice-app
  labels:
    app: practice-app
spec:
  replicas: 1
  selector:
    matchLabels:
      app: practice-app
  template:
    metadata:
      labels:
        app: practice-app
    spec:
      initContainers:
      - name: wait-mysqldb
        image: busybox:1.28
        command: ['sh', '-c', "until sleep 1 | telnet mysqldb-service 3306 ; do echo waiting ; sleep 2; done; "]
      containers:
      - name: practice-app
        image: altwal/practice:{{MYIMAGETAG}}
        ports:
        - containerPort: 8090
        env:
        - name: SPRING_DATASOURCE_URL
          value: jdbc:mysql://mysqldb-service:3306/assignment?allowPublicKeyRetrieval=true
        - name: SPRING_DATASOURCE_USERNAME
          valueFrom: 
            secretKeyRef:
              name: mysqldb-secret
              key: mysql-user
        - name: SPRING_DATASOURCE_PASSWORD
          valueFrom: 
            secretKeyRef:
              name: mysqldb-secret
              key: mysql-user-password
        livenessProbe:
            httpGet:
              path: /actuator/health
              port: 8090
            initialDelaySeconds: 50
            periodSeconds: 15
        readinessProbe:
            httpGet:
              path: /actuator/health
              port: 8090
            initialDelaySeconds: 50
            periodSeconds: 15
---
apiVersion: v1
kind: Service
metadata:
  name: practice-app-service
spec:
  selector:
    app: practice-app
  type: NodePort  
  ports:
    - protocol: TCP
      port: 8090
      targetPort: 8090
      nodePort: 30001
